#include <stdio.h>
#include <string.h>

void help()
{
	printf("Usage :hexasc [OPT] -i filename\n");
	printf("print file, in hex + ASCII, to std output \n\n");
	printf("  -b,-h,-w  by byte, halfword(default), word\n");
	printf("  --help    & exit\n");
	printf("  --version & exit\n");
}

void version()
{
	printf("hexasc- GONDOUIN O V & V99.99\n");
}

main(int argc, char *argv[])
{
	int i , mod = 2, mode = 0;
	long j = 0;
	unsigned char x[21];
	FILE *fp;
	x[20] = 0;	
	if (argc >1)
		for(i=1; i<argc; i++)
		{
			if (!strcmp(argv[i],"--help")) {help(); return 0;}	
			if (!strcmp(argv[i],"--version")) {version(); return 0;}	
			if (!strcmp(argv[i],"-b")) {mod = 1;}
			if (!strcmp(argv[i],"-h")) {mod = 2;}
			if (!strcmp(argv[i],"-w")) {mod = 4;}
			if (!strcmp(argv[i],"-i")) {i++; fp = fopen(argv[i],"r");
									if (!fp) {printf("file not found\n"); return 0;}
									else mode = 1; }
		}
	else {help(); return 0;}
	
	i = j = 0;
	printf("%X:\t",j);
	x[i] = fgetc(fp);
	while(!feof(fp))
	{
		if (x[i] < 0x10) printf("0%x",x[i]);
		else printf("%X",x[i]);
		if (x[i] < 32) x[i]='.';
		i++;
		if (i==20) {i = 0; j+=20; printf("\t%s\n%X:\t",x,j);}
		else if (!(i % mod)) putchar(' ');
		x[i] = fgetc(fp);
	}
	fclose(fp);
	printf("\t%s\n",x);
}

